use _SQL_SESSION_SIF


-- Exercice 1 :: trouver toutes les sessions faites par le formateur RAVENNE 
-- Rsultat : 18 formations

-- champs : formateurid (jointure) , nom (formateur) --> table formateur
           -- table session : sessionid

select 
Session_ID,
nom
from
session s inner join Formateur F
on S.FormateurID = f.Formateur_ID
where
nom = 'ravenne'


-- Exercice 2 : trouver les villes dans lesquelles est intervenu m.ravenne
-- Rsultat : 7 villes

select distinct
Ville,
Nom

from 
ville inner join session
on Ville.Ville_ID = session.VilleID

inner join Formateur
on session.FormateurID = Formateur.Formateur_ID

where nom = 'ravenne'


-- Exercice 3 : Idem avec ALIAS pour les tables relies

select distinct
a.Ville,
c.Nom

from 
ville a inner join session b
on a.Ville_ID = b.VilleID

inner join Formateur c
on b.FormateurID = c.Formateur_ID

where nom = 'ravenne'  


-- Exercice 4 : A paris, quels ont t les thmes enseigns par RAVENNE
-- Rsultat : 3 thmes enseigns

select distinct
a.Ville,
c.Nom,
f.theme

from 
ville a inner join session b
on a.Ville_ID = b.VilleID

inner join Formateur c
on b.FormateurID = c.Formateur_ID

inner join theme f
on f.Theme_ID=b.ThemeId

where nom = 'ravenne'  
and ville = 'Paris'


-- Exercice 5 : A lyon, quels ont t les thmes enseigns par RAVENNE et BOUORD (affichage des noms des formateurs) 
-- Rsultat avec noms des formateurs: 6 lignes
-- Rsultat sans les noms des formateurs (pas de doublons sur thmes) : 4 lignes

select distinct
a.Ville,
c.Nom,
f.theme

from 
ville a inner join session b
on a.Ville_ID = b.VilleID

inner join Formateur c
on b.FormateurID = c.Formateur_ID

inner join theme f
on f.Theme_ID=b.ThemeId

where nom in ('ravenne', 'bouord') 
and ville = 'LYON'


--  Exercice 6 : A paris, quels ont t les thmes enseigns  Paris, par quels formateurs (except par le formateur RAVENNE) 
--  et quels sont leur sexe? 
--  Rsultat : 2 Thmatiques par BOUORD

select distinct
a.Ville,
c.Nom,
f.theme,
c.sexe

from 
ville a inner join session b
on a.Ville_ID = b.VilleID

inner join Formateur c
on b.FormateurID = c.Formateur_ID

inner join theme f
on f.Theme_ID=b.ThemeId

where c.nom not in ('ravenne') 
and a.ville = 'Paris'


-- Exercice 7 : Quelles sont les stagiaires qui ont assist aux formations de durand et ravenne en 2016 tout en affichant la date ?
-- Rsultat : 52 lignes

select distinct
e.nom as 'nom stagiaire',
e.Prenom,
--c.Nom as 'nom formateur'
b.sessiondate as 'date de formation'

from 
stagiaire e inner join StagiairesSessions d
		on e.StagiaireID = d.stagiaire_ID
			inner join session b
		on d.session_ID = b.session_ID
			inner join formateur c
		on c.Formateur_ID = b.FormateurID

where c.nom in ('ravenne', 'durand') 
and year(b.sessionDate) = '2016'


-- Exercice 8 : Tous les stagiaires qui ont ralis une formation sans les doublons sur stagiaires
-- Rsultat : 236 lignes

select distinct 
	d.Stagiaire_ID
	/*e.Nom,
	e.Prenom */

from
	stagiaire e inner join StagiairesSessions d
					on e.StagiaireID=d.Stagiaire_ID
				inner join session b 
					on b.Session_ID = d.Session_ID


-- Exercice 9 : Trouver tous les stagiaires qui ont ralis une formation SQL
-- Rsultat : 188

select distinct
	e.nom,
	e.prenom,
	e.StagiaireID
from 
	stagiaire e inner join stagiairessessions d
					on e.stagiaireID = d.stagiaire_ID
				inner join session b
					on b.session_ID = d.session_ID
				inner join theme f
					on b.themeID = f.theme_ID
where
		f.theme like '%SQL%'


-- 9.2 : Toujours les stagiaires avec une formation dont le titre contient "SQL" mais pas le mot "donnes"
-- Rsultat : 129 lignes

select distinct
	e.StagiaireID

from
	stagiaire e inner join StagiairesSessions d
					on e.StagiaireID=d.Stagiaire_ID
				inner join session b 
					on b.Session_ID = d.Session_ID
				inner join theme f
					on b.themeID = f.theme_ID

				where f.Theme like '%SQL%' and f.Theme  not like '%donnes%'

-- 9.3 : La liste des formations ralises (leur nom : sql 2012 par exemple) dont le titre contient SQL mais pas donnes
-- Rsultat : 5 lignes si le themeid n'est pas dans le select
-- 6 rsultats si themeid (car doublons sur un libell de thme avec deux id diffrents)

select distinct
	f.theme
from
		session b join
		theme f
			on b.themeID = f.theme_ID

where f.Theme like '%SQL%' and f.Theme  not like '%donnes%'

-- Exercice 10 : Trouver le nombre de formations ralises par formateur et par anne
-- Trie par nom de formateur puis par anne
-- Rsultat : 10 lignes

Select
c.Nom as 'nom formateur',
year(b.sessiondate) as 'anne formation',
count(b.session_ID) as 'nombre de formations ralises'

from
formateur c inner join session b
		on c.formateur_ID=b.formateurID

Group by
c.nom,
year(b.sessiondate)
order by 'nom formateur', 'anne formation'



