------------------------- JOINTURES -----------------------------------------

-- A. Je veux les produits (Productname) pour lesquels le prix  l'unit (unitprice de la table factOnlineSales) 
-- est gal  429 ou 179 par ordre de produit
-- ici la cl primaire de la table product est ProductKey 
-- Rsultat : 14 lignes

use ContosoRetailDW

select distinct
	DP.ProductName,
	FOS.UnitPrice

from DimProduct DP inner join FactOnlineSales FOS
	on dp.ProductKey=FOS.ProductKey
	-- je vais joindre la table FactOnlineSales (que je renomme FOS) avec la table DimProduct (que je renomme DP)
	-- en utilisant la cl cl primaire (ProductKey) de la table Product
	-- et je dis qu'elle est gale  la cl trangre (productkey) sur la table FOS

where FOS.UnitPrice in ('429','179')
order by 
ProductName

-- B Je souhaite connatre les produits qui font partie d'une catgorie qui contient des desserts
-- qui ont des stocks (produitunitsinstock) entre 49 et 76
-- par ordre alphabtique de nom de produit
-- ici la cl primaire de la table categorie est categorieID
-- Rsultat : 3 lignes

use comptoir

select distinct
	P.ProduitUnitsInStock,
	P.Produit
from T_produit P inner join T_Categorie C
		on P.CategorieID=C.CategorieID
where 
	C.CategorieDescription like '%desserts%' 
and P.ProduitUnitsInStock between '49' and '76'

order by
	P.produit

-- C Quelle est la moyenne des quantits des ventes pour le produit zaanse koeken ?
-- ici la cl primaire de la table produit est ProduitID 
-- Rsultat : moyenne de 23

use comptoir

select
-- P.produit,
avg(DC.Qte_vente) as 'moyenne des ventes'
from T_DetaillerCommande DC inner join T_Produit P
		on DC.ProduitID=P.ProduitID
where
	P.produit ='zaanse koeken'

-- D Concernant les desserts (categorie description) et produce (categorie), quelle est la somme des ventes de ce type de produits?
-- Je veux la somme par catgorie !
-- ici la cl primaire de la table produit est ProduitID
-- ici la cl primaire de la table catgorie est CategorieID 
-- Rsultat: 2 lignes

use comptoir

select
-- P.produit,
C.Categorie,
sum(DC.Qte_vente) as 'somme des ventes'

from T_DetaillerCommande DC 
inner join T_Produit P
		on DC.ProduitID=P.ProduitID
inner join T_Categorie C
		on P.CategorieID=C.CategorieID
where
	C.CategorieDescription like '%desserts%'
	or C.Categorie like '%produce%'

group by 
C.Categorie
-- Categoriedescription ne fonctionne pas en group by et dans select distinct car non compatible avec ntxte (type de donnes)


-- E. Nbr de commandes et CA par client, par anne et par catgorie
-- Rsultat : 819

use comptoir
--client=a , commande=b, detaillercommande=d, produit=e, categorie=c
select distinct
	a.clientnom as 'nom client',
	year(b.cdedate) as 'annee',
	c.categorie as 'categorie',
	count(d.cdenum) as 'nombre de commandes'
, sum(d.pu_vente* d.Qte_vente) as 'chiffre d''affaire'

from 
	t_client a  inner join t_commande b
					on a.clientID = b.clientID
				inner join T_DetaillerCommande d
					on  b.cdenum = d.cdenum
				inner join t_produit e
					on d.ProduitID = e.ProduitID
				inner join T_Categorie c
			on e.CategorieID=c.CategorieID
group by
	a.clientnom,
	year(b.cdedate),
	c.categorie


-- E.2 Nbr de commandes et CA par client, par anne et par catgorie
-- Reprendre sur requte E et supprimer l'anne dans select et group by
-- Quand l'anne de commande est 2006
-- Que le chiffres d'affaires est suprieur  500
-- Trier sur nombre de commandes (+ grand au plus petit)
-- Rsultat : 385 lignes
select distinct
	a.clientnom as 'nom client',
	c.categorie as 'categorie',
	count(d.cdenum) as 'nombre de commandes'
, sum(d.pu_vente* d.Qte_vente) as 'chiffre d''affaire'
from t_client a  inner join t_commande b on a.clientID = b.clientID
				inner join T_DetaillerCommande d on  b.cdenum = d.cdenum
				inner join t_produit e on d.ProduitID = e.ProduitID
				inner join T_Categorie c on e.CategorieID=c.CategorieID
where year(cdedate) = 2006
group by a.clientnom,c.categorie
Having sum(d.pu_vente* d.Qte_vente) > 500
order by count(d.cdenum) desc

-- F. Quels sont les produits commands + de 20 fois ?  
-- Rsultat: 52 lignes correspondant au nombre de commandes

SELECT count(distinct CdeNum) as 'Nombre de commandes',
		sum(Qte_vente) as 'Nombre de quantits de ventes',
		Produit
FROM T_DetaillerCommande as DC JOIN T_Produit as p
			on dc.ProduitID=p.ProduitID
GROUP BY Produit
HAVING -- sum(Qte_vente) > 800 
		count(distinct CdeNum) > 20


-- G.1 - Je souhaite connatre le listing des villes de ma table VILLE : 10
use _SQL_SESSION_SIF
select distinct
 Ville
 from ville

-- G.2 -- Je souhaite avoir les villes pour lesquelles une session a t ralise : 8

select distinct
 v.Ville

 from ville v join Session s
	on v.Ville_ID =  s.VilleID

-- G.3 Je souhaite avoir les villes pour lesquelles il n'y a pas eu de session ralise : 2
select distinct
 ville.Ville, ville.Ville_ID

 from ville left join Session
	on ville.Ville_ID =  session.VilleID
 where session.VilleID IS NULL

-- G.4 je souhaite avoir exactement le mme rsultat que G3 mais en crivant un right join
select distinct
 ville.Ville, ville.Ville_ID

 from session right join ville
	on ville.Ville_ID =  session.VilleID
 where session.VilleID IS NULL

-- G.5 Je souhaite maintenant connatre les sessions pour lesquelles il n'y a pas de ville renseigne : 1

select
session.Session_ID
-- ville.Ville_ID
 from ville right join Session
	on ville.Ville_ID =  session.VilleID
where Ville.Ville_ID is null

-- mais pas la peine de faire right join, juste en regardant sur la table session, on voit qu'un IDville est NULL
select
Session_ID
 from Session
where Session.VilleID is null


-- G.6 Je souhaite avoir le nom du formateur concern par les sessions  distance (donc sans ville) : 1
-- dans SQL_SESSION_SIF
select
session.Session_ID,
formateur.Nom
 from Session left join ville
	on ville.Ville_ID =  session.VilleID
			join Formateur
	on session.FormateurID=Formateur.Formateur_ID
where Ville.Ville_ID is null


-- H.1 - souhaite avoir le nom des produits qui ont t vendus
-- En partant de la Table Dimproduct vers factonlinesales 

Use contosoretailDW

-- les produits de la table produit : 2517
select distinct ProductKey
from DimProduct


-- les produits qui ont t vendu (dans les deux tables) : 2516
select distinct dimproduct.productKey, ProductName
from dimproduct join factonlinesales
	on DimProduct.ProductKey=FactOnlineSales.ProductKey


-- H.2 -- les produits qui n'ont pas t vendu (dans 1 seule table et qui n'existe pas dans l'autre)
-- Rsultat: 1 rponse (A. Datum Compact Digital Camera M200 Black)

select distinct dimproduct.productKey, ProductName
from dimproduct left join factonlinesales  -- je rajoute un left
	on DimProduct.ProductKey=FactOnlineSales.ProductKey
	-- ici si je ne mets pas ma condition : tous les produits qui existent dans les deux tables
	-- avec le produit dans la table FOS qui est NULL (car pas vendu)
	-- je vais donc vouloir l'enlever
	-- order by dimproduct.productKey -- (pour retrouver le 944 NULL sur FOS)
	where FactOnlineSales.ProductKey is null -- je rajoute ma condition d'absence dans la 2nde table) 



