USE ContosoRetailDW

-- 1 : Nombres de commandes passes en 2007 par pays et tranche d'ge des clients
-- ATTENTION : ge cr en fonction de la date de naissance et date de chargement (loaddate)
-- TA : moins de 20 ans, 20  29 ans, 30  39 ans, 40  49 ans, 50  59 ans, 60 ans et plus
-- Rsultat : 47 lignes et 18 lignes si on ne veut pas lignes avec birthdate connu (date d'aujourd'hui OCT 2020)
-- Rsultat : 59 lignes et 30 lignes si on ne veut pas lignes avec birthdate connu (date de chargement)

USE ContosoRetailDW

SELECT dg.RegionCountryName as 'pays',
case 
when datediff(year,dc.BirthDate,dc.LoadDate) <20 then 'moins de 20 ans'
when datediff(year,dc.BirthDate,dc.LoadDate) between 20 and 29 then '20-29 ans'
when datediff(year,dc.BirthDate,dc.LoadDate) between 30 and 39 then '30-39 ans'
when datediff(year,dc.BirthDate,dc.LoadDate) between 40 and 49 then '40-49 ans'
when datediff(year,dc.BirthDate,dc.LoadDate) between 50 and 59 then '50-59 ans'
when datediff(year,dc.BirthDate,dc.LoadDate) > 59 then '60+'
ELSE 'inconnu'
end as 'tranche d''age',
count(fo.OnlineSalesKey) as 'nbre de commande'

FROM FactOnlineSales FO JOIN DimCustomer DC
			ON fo.CustomerKey=dc.CustomerKey
						JOIN DimGeography dg
			ON dg.GeographyKey=dc.GeographyKey

WHERE year(fo.DateKey)='2007' -- and year(Dc.birthdate) IS NOT NULL
group by dg.RegionCountryName,
case 
when datediff(year,dc.BirthDate,dc.LoadDate) <20 then 'moins de 20 ans'
when datediff(year,dc.BirthDate,dc.LoadDate) between 20 and 29 then '20-29 ans'
when datediff(year,dc.BirthDate,dc.LoadDate) between 30 and 39 then '30-39 ans'
when datediff(year,dc.BirthDate,dc.LoadDate) between 40 and 49 then '40-49 ans'
when datediff(year,dc.BirthDate,dc.LoadDate) between 50 and 59 then '50-59 ans'
when datediff(year,dc.BirthDate,dc.LoadDate) > 59 then '60+'
ELSE 'inconnu'
end

order by dg.RegionCountryName, [tranche d'age]

-----------------------------------------------------------
use comptoir

-- 2. Je souhaite compter le nombre de produits commands par date (caste en date simple)
-- Quand le prix unitaire des ventes est entre 20 et 60
-- Quand les catgories de produits sont de type Beverage, Condiment, Confection et Dairy T_Produit
-- Quand les CommandeTransportVIA sont gales  2
-- Dans Comptoir - Rsultat : 120 lignes

select cast(T_Commande.CdeDate as date) as 'Date de commande',
		count(T_Produit.ProduitID) as 'Nombre du produits'

from T_Commande join T_DetaillerCommande
	on T_Commande.cdeNum=T_detaillerCommande.cdenum
				join T_Produit
	on T_produit.ProduitID=T_DetaillerCommande.ProduitID
				join T_Categorie
	on T_Produit.CategorieID=T_Categorie.CategorieID

where T_DetaillerCommande.PU_Vente between 20 and 60
		and T_Categorie.Categorie in ('Beverages','Condiments','Confections','Dairy T_Produit')
		and T_Commande.CommandeTransportVia = 2

group by cast(T_Commande.CdeDate as date)

-----------------------------------------------------------------------------------------
-- 3 -je veux le nombre de stagiaires par date et ID
-- je veux aussi une nouvelle variable de gestion du nombre de stagiaire qui nous informera sur : quand le nombre de stagiaire est plus petit que 5 alors " complter" et plus petit que 10 "ok", sinon 'dplacer stagiaire'

USE _SQL_SESSION_SIF

select
a.Session_ID,
a.SessionDate,
count(b.Stagiaire_ID) as 'nb stagiaires',
case
	when count(b.Stagiaire_ID) <5 then 'a complter'
	when count(b.Stagiaire_ID) <10 then 'ok'
	else 'dplacer stagiaire'
end as 'gerer nombre de stagiaires'

from session a inner join StagiairesSessions b
on a.Session_ID =b.Session_ID

group by
a.Session_ID,
a.SessionDate


-- 4 - villes et sessions : si la ville est paris ou Lille informer par une nouvelle variable que c'est le nord et si lyon ou marseille le sud
-- afficher le nombre de sessions par ville ET par anne
-- en utilisant les alias de table
select
case
	when a.Ville in ('Paris', 'Lille', 'Strasbourg','Nantes') then 'Nord'
	when a.Ville in ('Nice', 'Marseille','lyon') then 'Sud'
	else 'autres'
	end as ville2,
year(b.sessiondate) as 'annee',
count(b.session_ID) as 'nb'
from ville a inner join session b
on a.Ville_ID =b.VilleID
group by
case
	when a.Ville in ('Paris', 'Lille', 'Strasbourg','Nantes') then 'Nord'
	when a.Ville in ('Nice', 'Marseille','lyon') then 'Sud'
	else 'autres'
	end,
year(b.sessiondate)
---------------------------------------------------------------------------------
-- 5 : je souhaite rcuprer les numro des produits (productnumber),
-- la listprice et le sellstartdate des produits n'ayant pas reu d'avis/commentaire
-- Table Production.Product --> produits
-- Table Production.ProductReview --> avis sur les produits
-- il est ncessaire de bien recrire tout le nom de la table production.product.champ
-- Rsultat : 501 lignes

use AdventureWorks2012

SELECT p.Name,
p.ProductNumber,
p.ListPrice,
p.SellStartDate
FROM Production.Product AS p
LEFT JOIN Production.ProductReview AS pr
ON p.ProductID = pr.ProductID
WHERE pr.ProductID IS NULL

-- 6 : Je souhaite rcuprer TOUS les adresstypename de la table Person.AdressType
-- qu'ils aient ou non de correspondance avec les tables Person.BusinessEntityAddress, Person.BusineeEntity,
-- et la table person.person car je souhaite rcuprer le BusinessEntityId sur la table Person.BusinessEntityAddress
-- ainsi que firstname et le lastname sur la table Person.person

-- Rsultat : 19617

SELECT pat.Name AS AddressTypeName, bea.BusinessEntityID, bea.AddressID,
		pp.FirstName, pp.LastName
FROM Person.AddressType pat
LEFT JOIN Person.BusinessEntityAddress bea
ON pat.AddressTypeID = bea.AddressTypeID
LEFT JOIN Person.BusinessEntity BE
On bea.BusinessEntityID=Be.BusinessEntityID
LEFT Join person.person pp
on be.BusinessEntityID=pp.BusinessEntityID
ORDER BY pat.AddressTypeID, bea.BusinessEntityID

-----------------------------------------------------------------------------------------

-- 7. Afficher le nom, l'id et le prix max pour chaque produit vendu (Tables Sales.SalesOrderDetail et Production.product)
-- Rsultat : 266 lignes
use AdventureWorks2012

Select sod.ProductID, P.name, max(sod.unitprice) as 'Prix max'
From sales.SalesOrderDetail sod join production.product p on sod.ProductID=p.ProductID
group by sod.ProductID, P.name
order by sod.ProductID desc

-- 8. Repartir sur requte prcdente : je veux n'afficher que les 15 produits les plus chers 
-- Rsultat : 266 lignes
use AdventureWorks2012

Select top 15 sod.ProductID, P.name, max(sod.unitprice) as 'Prix max'
From sales.SalesOrderDetail sod join production.product p on sod.ProductID=p.ProductID
group by sod.ProductID, P.name
order by sod.ProductID desc

-- 9. Quels sont les produits qui n'ont jamais t vendu ?
-- Rsultat : 238 produits
Select distinct p.ProductID, p.name
From sales.SalesOrderDetail sod right join production.product p on sod.ProductID=p.ProductID
Where sod.ProductID IS NULL

-- 10. Ecrire cette requte avec un UNION/Intersect ou Except -- Le problme : nous ne pouvons pas afficher le nom
Select distinct ProductID
From production.product
		EXCEPT
Select distinct ProductID
From sales.SalesOrderDetail 